-- name: [CS] Annalynn Midway
-- description: The Miner of canada(?

if not _G.charSelectExists then
    djui_popup_create("\\#ffffa0\\urmod requires\nCharacter Select to be enabled.\n\nPlease rehost with it enabled.", 4)
    return
end

-- Characters are stored in a table for ease of addition

Annalynn = {
    --------------
    -- Annalynn --
    --------------
    {
        name = "Annalynn",
        description = "Annalynn midway she's a 23 year old miner. (aslo canadian)",
        credits = "Dede_doo, Silly runner, Oliaker, saul, Sonks132",
        color = { r = 0, g = 70, b = 161 },
        model = smlua_model_util_get_id("anna_geo"),
		star = smlua_model_util_get_id("ruby_geo"),
        forceChar = CT_MARIO,
        lifeIcon = get_texture_info("anna-icon"),
        camScale = 0.8,
        offset = 0,
		caps = {
            wing = smlua_model_util_get_id("annalynnwing_geo"),
            metal = smlua_model_util_get_id("annalynnmetal_geo"),
        },
        palette = {
            [PANTS]  = { r = 0x00, g = 0x3c, b = 0xff },
            [SHIRT]  = { r = 0x00, g = 0xad, b = 0xff },
            [GLOVES] = { r = 0xff, g = 0xff, b = 0xff },
            [SHOES]  = { r = 0x00, g = 0xad, b = 0xff },
            [HAIR]   = { r = 0x64, g = 0x2c, b = 0x00 },
            [SKIN]   = { r = 0xfe, g = 0xc1, b = 0x79 },
            [CAP]    = { r = 0x00, g = 0xad, b = 0xff },
            [EMBLEM] = { r = 0x00, g = 0x00, b = 0xff },
        },
        voices = {
            [CHAR_SOUND_ATTACKED] = "Ack.ogg",
            [CHAR_SOUND_DOH] = "Ow (1).ogg",
            [CHAR_SOUND_DROWNING] = {"Drowning (1).ogg", "Drowning (2).ogg"},
            [CHAR_SOUND_DYING] = "Oh no.ogg",
            [CHAR_SOUND_EEUH] = "Mm-mmm.ogg",
            [CHAR_SOUND_GROUND_POUND_WAH] = "Tasty (2).ogg",
            [CHAR_SOUND_HAHA] = "Ha-ha (1).ogg",
            [CHAR_SOUND_HAHA_2] = "Ha-ha (2).ogg",
            [CHAR_SOUND_HERE_WE_GO] = {"You're mine now.ogg", "Ruby Time.ogg"},
            [CHAR_SOUND_HOOHOO] = "Hah (2).ogg",
            [CHAR_SOUND_HRMM] = "Yum.ogg",
            [CHAR_SOUND_IMA_TIRED] = "Ruby Time.ogg",
            [CHAR_SOUND_MAMA_MIA] = "Let's get digging (1).ogg",
            [CHAR_SOUND_LETS_A_GO] = "Here I come.ogg",
            [CHAR_SOUND_ON_FIRE] = "Hot.ogg",
            [CHAR_SOUND_OOOF] = "Ow (3).ogg",
            [CHAR_SOUND_OOOF2] = "Ow (2).ogg",
            [CHAR_SOUND_PUNCH_HOO] = "Hya.ogg",
            [CHAR_SOUND_PUNCH_WAH] = "Pow (1).ogg",
            [CHAR_SOUND_PUNCH_YAH] = "Pow (2).ogg",
            [CHAR_SOUND_SO_LONGA_BOWSER] = "Time to fly (1).ogg",
            [CHAR_SOUND_TWIRL_BOUNCE] = "Bravo.ogg",
            [CHAR_SOUND_UH] = "Ow (1).ogg",
            [CHAR_SOUND_UH2] = "Yowch (1).ogg",
            [CHAR_SOUND_UH2_2] = "Yowch (2).ogg",
            [CHAR_SOUND_WAAAOOOW] = "Waaaaa.ogg",
            [CHAR_SOUND_WAH2] = "Here I come.ogg",
            [CHAR_SOUND_WHOA] = "Woah.ogg",
            [CHAR_SOUND_YAHOO] = "Shiny.ogg",
            [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = "Amazing.ogg",
            [CHAR_SOUND_YAH_WAH_HOO] = "Hah (1).ogg",
            [CHAR_SOUND_HELLO] = "Sayonara.ogg",
        },
        anims = {
            [CHAR_ANIM_IDLE_HEAD_CENTER] = 'anna_center',     -- thank you frijoles xd
            [CHAR_ANIM_IDLE_HEAD_LEFT] = 'anna_left',
            [CHAR_ANIM_IDLE_HEAD_RIGHT] = 'anna_right',
        }
    },
}

local CSloaded = false
local function on_character_select_load()
    for i = 1, #Annalynn do
        local char = Annalynn[i]
        char.tablePos = _G.charSelect.character_add(char.name, char.description, char.credits, char.color, char.model, char.forceChar, char.lifeIcon, char.camScale, char.offset)
        if char.caps then _G.charSelect.character_add_caps(char.model, char.caps) end
        if char.voices then _G.charSelect.character_add_voice(char.model, char.voices) end
        if char.palette then _G.charSelect.character_add_palette_preset(char.model, char.palette) end
        if char.anims then _G.charSelect.character_add_animations(char.model, char.anims) end
		if char.star then _G.charSelect.character_add_celebration_star(char.model, char.star) end
    end

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    for i = 1, #Annalynn do
        if _G.charSelect.character_get_voice(m) == Annalynn[i].voices then return _G.charSelect.voice.sound(m, sound) end
    end
end

local function on_character_snore(m)
    if not CSloaded then return end
    for i = 1, #Annalynn do
        if _G.charSelect.character_get_voice(m) == Annalynn[i].voices then return _G.charSelect.voice.snore(m) end
    end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)